<script lang="ts">
  import type { Competition } from '@types';
  import { Card, Listgroup, Heading, Tooltip } from 'flowbite-svelte';
  import Fa from 'svelte-fa';
  import { faShareAlt } from '@fortawesome/free-solid-svg-icons';
  import Tag from '$lib/Tag.svelte';
  import { browser } from '$app/environment';

  export let name: string;
  export let data: Competition;
  export let nameLink = false;
  export let utm_content: string | null = null;
  const placeholderDescription = 'No description available. Feel free to request or suggest one!';
  let linkCopied = false;

  let list: { name: string; description: string; value: string }[] = [];
  $: if (data) {
    const props = [
      ['education_target', 'Target Audience', 'Who should participate?'],
      ['eligibility', 'Eligibility', 'Any restrictions on participation.'],
      ['practice_available', 'Practice Available', 'Is there an training available?'],
      ['qualifiers', 'Qualifiers', 'Is there a qualifier?'],
      ['teams', 'Teams', 'Is this a team competition?'],
      ['virtual', 'Virtual', 'Is the competition available virtually?']
    ];
    const newList = [];
    for (const item of props) {
      if (data.properties[item[0]]) {
        newList.push({
          name: item[1],
          description: item[2],
          value: String(data.properties[item[0]])
        });
      }
    }
    list = newList;
  }
  function copyUrlToClipboard() {
    const url = new URL(`/competitions/${name}`, window.location.href);
    // track that the url was generated with the share link button
    url.searchParams.set('utm_source', 'share_link');

    if (utm_content) {
      // track what page the link was shared from
      url.searchParams.set('utm_content', utm_content);
    }

    navigator.clipboard.writeText(url.href);
    linkCopied = true;
    setTimeout(() => {
      linkCopied = false;
    }, 4000);

    if (browser && window?.umami) {
      window.umami.track('Copy Share Link', { url: url.href, competition: name });
    }
  }
</script>

<Card size="xl" padding="xl">
  <div class="mb-2">
    <Heading tag="h2" class="w-auto inline">
      {#if nameLink}
        <a target="_blank" href="/competitions/{name}">{name}</a>
      {:else}
        {name}
      {/if}
    </Heading>
    <button on:click={copyUrlToClipboard} on:keyup={copyUrlToClipboard} class="cursor-pointer">
      <Fa class="inline-block mx-1" icon={faShareAlt} /> Share
    </button>
    <Tooltip open={linkCopied}>
      {linkCopied ? 'URL copied to clipboard!' : 'Copy share url to clipboard'}
    </Tooltip>
  </div>
  {#if data.properties.tags.length > 0}
    <div class="flex flex-wrap justify-left items-center gap-1 pb-1">
      {#each data.properties.tags as tag}
        <Tag {tag} />
      {/each}
    </div>
  {/if}
  <p class="mb-3 font-normal text-gray-700 dark:text-gray-400 leading-tight">
    {data.properties.description || placeholderDescription}
  </p>
</Card>

{#if list && list.length > 0}
  <Card size="xl" class="my-2">
    <Heading tag="h5">Attributes</Heading>
    <Listgroup items={list} let:item class="border-0 dark:!bg-transparent">
      <div class="flex items-center space-x-4">
        <div class="flex-1 min-w-0">
          <p class="text-sm font-semibold text-gray-900 truncate dark:text-white">
            {item.name}
          </p>
          <p class="text-sm text-gray-500 dark:text-gray-400">
            {item.description}
          </p>
        </div>
        <div class="flex-1 items-center text-base text-gray-900 dark:text-white">
          {item.value}
        </div>
      </div>
    </Listgroup>
  </Card>
{/if}

{#if data.properties.links && data.properties.links.length > 0}
  <Card size="xl" class="my-2">
    <Heading tag="h5">Links</Heading>
    <Listgroup items={data.properties.links} let:item class="border-0 dark:!bg-transparent">
      <div class="flex items-center space-x-4">
        <div class="flex-1 min-w-0">
          <p class="text-sm font-semibold text-gray-900 dark:text-white">
            <a target="_blank" href={item.link}>{item.title}</a>
          </p>
          {#if item.description}
            <p class="text-sm text-gray-500 dark:text-gray-400">
              {item.description}
            </p>
          {/if}
        </div>
      </div>
    </Listgroup>
  </Card>
{/if}
